using System;
using System.Collections.Generic;
using System.Globalization;

namespace Turbo.Plugins.Default
{

    public class ArchonPlugin : BasePlugin, IInGameTopPainter
    {
		public HorizontalTopLabelList LabelListUnstable { get; private set; }
		public HorizontalTopLabelList LabelListChantodo { get; private set; }
		public HorizontalTopLabelList LabelListArchon { get; private set; }
		public HorizontalTopLabelList LabelListKarini { get; private set; }
		
        public ArchonPlugin()
            : base()
        {
		    Enabled = true;
        }
		
        public override void Load(IController hud)
        {
            base.Load(hud);
		
			LabelListUnstable = new HorizontalTopLabelList(hud);

            LabelListUnstable.LeftFunc = () =>
            {
                return Hud.Window.Size.Width / 2f;
            };
            LabelListUnstable.TopFunc = () =>
            {
                return Hud.Window.Size.Height * 0.1f;
            };
            LabelListUnstable.WidthFunc = () =>
            {
                return 0;
            };
            LabelListUnstable.HeightFunc = () =>
            {
                return 0;
            };
						
            LabelListUnstable.LabelDecorators.Add(new TopLabelDecorator(Hud)
            {								
				TextFont = Hud.Render.CreateFont("tahoma", 30, 255, 255, 0, 0, true, false, true),
				TextFunc = () => "春哥!!!!!!!!!!",
            });
						
            LabelListChantodo = new HorizontalTopLabelList(hud);

            LabelListChantodo.LeftFunc = () =>
            {
                return Hud.Window.Size.Width / 2f;
            };
            LabelListChantodo.TopFunc = () =>
            {
                return Hud.Window.Size.Height * 0.351f;
            };
            LabelListChantodo.WidthFunc = () =>
            {
                return 0;
            };
            LabelListChantodo.HeightFunc = () =>
            {
                return 0;
            };
					
            LabelListChantodo.LabelDecorators.Add(new TopLabelDecorator(Hud)
            {								
				TextFont = Hud.Render.CreateFont("tahoma", 14, 255, 0, 255, 0, true, false, true),
				TextFunc = () => "朵套  " + Hud.Game.Me.Powers.GetBuff(440235).IconCounts[0].ToString() + "  黑人  " +  (Hud.Game.Me.Powers.BuffIsActive(134872) ? (Hud.Game.Me.Powers.GetBuff(134872).IconCounts[2] + Hud.Game.Me.Powers.GetBuff(134872).IconCounts[5]).ToString(): "无"),
            });
			
            LabelListArchon = new HorizontalTopLabelList(hud);

            LabelListArchon.LeftFunc = () =>
            {
                return Hud.Window.Size.Width / 2f;
            };
            LabelListArchon.TopFunc = () =>
            {
                return Hud.Window.Size.Height * 0.25f;
            };
            LabelListArchon.WidthFunc = () =>
            {
                return 0;
            };
            LabelListArchon.HeightFunc = () =>
            {
                return 0;
            };
					
            LabelListArchon.LabelDecorators.Add(new TopLabelDecorator(Hud)
            {								
				TextFont = Hud.Render.CreateFont("tahoma", 20, 255, 255, 0, 0, true, false, true),
				TextFunc = () => "黑人倒数  " +  ((int)(Hud.Game.Me.Powers.GetBuff(134872).TimeLeftSeconds[2])).ToString(),
            });
			
			LabelListKarini = new HorizontalTopLabelList(hud);

            LabelListKarini.LeftFunc = () =>
            {
                return Hud.Window.Size.Width / 2f;
            };
            LabelListKarini.TopFunc = () =>
            {
                return Hud.Window.Size.Height * 0.1f;
            };
            LabelListKarini.WidthFunc = () =>
            {
                return 0;
            };
            LabelListKarini.HeightFunc = () =>
            {
                return 0;
            };
						
            LabelListKarini.LabelDecorators.Add(new TopLabelDecorator(Hud)
            {								
				TextFont = Hud.Render.CreateFont("tahoma", 30, 255, 255, 0, 0, true, false, true),
				TextFunc = () => "无电戒!!!!!!!!!!",
            });
        }

        public void PaintTopInGame(ClipState clipState)
        {
            if (clipState != ClipState.BeforeClip || Hud.Game.IsInTown || (Hud.Game.Me.HeroClassDefinition.HeroClass != HeroClass.Wizard)) return;
            
			bool speak = Hud.Sound.LastSpeak.TimerTest(1000);
			
			LabelListChantodo.Paint();
			
			if (Hud.Game.Me.Powers.BuffIsActive(208474, 1))
			{
				LabelListUnstable.Paint();
				if (speak)
				{
					Hud.Sound.Speak("春哥");
				}
			}

			if (Hud.Game.Me.Powers.BuffIsActive(430674, 1) && Hud.Sound.LastSpeak.TimerTest(2000))
			{
				Hud.Sound.Speak("准备");
			}
			if (Hud.Game.Me.Powers.BuffIsActive(430674, 2) && speak)
			{
				Hud.Sound.Speak("爆发");
			}
						
			if (!Hud.Game.Me.Powers.BuffIsActive(74499, 4) && Hud.Game.Me.Density.GetDensity(50) > 0)
			{
				LabelListKarini.Paint();
			}
						
			if (Hud.Game.Me.Powers.BuffIsActive(134872, 2))				
			{
				var time = (int)(Hud.Game.Me.Powers.GetBuff(134872).TimeLeftSeconds[2]);
				if (time < 6)
				{
					LabelListArchon.Paint();
					if (speak)
					{
					Hud.Sound.Speak(time.ToString());
					}
				}
			}
        }
    }
}